// CNX
class CrossPoint : public MQSelectPlugin
{
public:
	CrossPoint();
	virtual ~CrossPoint();

	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	virtual const char *GetPlugInName(void);
	virtual const char *EnumString(int index);
	virtual BOOL Execute(int index, MQDocument doc);

	BOOL main();
private:
	cmq::CMQDocument doc;
	cmq::CMQObject obj;

	std::vector<std::pair<cmq::findex_t, int>> getSelectedLine();
	BOOL getNearPoint(std::pair<cmq::findex_t, int> &line1,
		std::pair<cmq::findex_t, int> &line2,
		std::vector<std::pair<MQPoint, float>> &ppair);
	BOOL separateFaces(std::pair<cmq::findex_t, int> &line1, std::pair<cmq::findex_t, int> &line2,
		std::pair<MQPoint, float> &p1, std::pair<MQPoint, float> &p2);
	BOOL addVertex2Face(cmq::findex_t findex, int lindex, int v1, float dp);
	BOOL separateLine(cmq::findex_t findex, int lindex, int v1, float dp);

	static const float delta;
};
